/*
 *  ISEM - Instructional Sparc EMulator and tkisem
 *  Copyright (C) 1993, 1994, 1995, 1996
 *	Department of Computer Science,
 *      The University of New Mexico
 *
 *  Please send questions, comments, and bug reports to: isem@cs.unm.edu
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// StorageDev.c -- definition of the  StorageDevice  class
//

#if __GNUC__
#define UNUSED __attribute__ ((unused)) 
#else
#define UNUSED
#endif

static char rcsid[] UNUSED = "$Id: st_dev.cpp 1.1 Fri, 25 Oct 1996 18:04:04 -0600 maccabe $";

#include "sizedefs.h"
#include "sys_bus.h"
#include "st_dev.h"


//
// public Constructors / Destructors
//
StorageDevice::StorageDevice(SystemBus& sb, UInt32 l, UInt32 h)
    : sbus(sb), _lowAddress(l), _highAddress(h)
{
}


//
// public Query functions
//
UInt32 StorageDevice::lowAddress() {
    return _lowAddress;
}

UInt32 StorageDevice::highAddress() {
    return _highAddress;
}
